//+------------------------------------------------------------------+
//|                                                  SimbaSystem.mq4 |
//|                      Simba, programmed by Malcik and popok_sakti |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

#property copyright "Simba, programmed by Malcik and popok_sakti"
#property link      "http://www.forex-tsd.com"

#define MAGICSS  20070129

extern bool    UseSATLFilter=true;     // when true, the EA will only go long/short when the price is above/below SATL (or any other MA)
extern int     ChandDist_Min=35;       // boundaries of distances of price from Chandelier
extern int     ChandDist_Max=100;      // self explanatory
extern bool    UseChandIfTouched=false;// if set to false, it will exit position if Chandelier is touched, otherwise, it will check chandelier every hour
extern int     WPR_Period=90;          // W%R period
extern int     WPR_TopLevel=-5;        // wpr top limit, default = -5
extern int     WPR_BottomLevel=-95;    // wpr limit, default = -95
extern int     NextPivotMaxDist=5;     // maximum distance before coming to a pivot laying forward to take the trade
extern int     LastPivotMaxDist=5;     // maximum distance from a pivot laying behind to which the price needs to retrace to take the trade
extern int     PivotWaitingTime=30;    // maximum time for retracement in previous setting
extern int     TPPips=355;             // self explanatory
extern bool    atr_for_tp=false;       // use Average True Range (daily) for take profit
extern int     atr_period=14;          // self explanatory
extern double  atr_multiplier=100;     // self explanatory
extern bool    AllowReentries=false;   // when true, more than 1 position can be open (reentries at each 10 pips of better price or after retracement of W%R)
extern int     MaximumRisk=0;          // integer number of percent of the account you want to risk per trade; if 0, no money management used

datetime LastMinute;
int      LongTrades=0;
int      ShortTrades=0;
bool     NextLongTrade=true;
bool     NextShortTrade=true;
bool     GoLong=false;
bool     GoShort=false;
double   FirstAbove,FirstBelow;
double   LongTradePrice=0;
double   ShortTradePrice=0;
datetime LongTradeExpiration,ShortTradeExpiration=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double   SATL,SATL_Prev,Chandelier_Up,Chandelier_Dn,WPR,spread;
   double   LotSize=1;
   int      res,i;
//----

   if(LastMinute!=Time[0])
     {
      spread=Ask-Bid;

      Chandelier_Up=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",0,1);
      Chandelier_Dn=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",1,1);
      LongTrades=0;
      ShortTrades=0;
      if(OrdersTotal()>0)
      {
         for(i=0;i<OrdersTotal();i++)
           {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
              {
               if(OrderType()==OP_BUY)
                 {
                  if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
                 }
               if(OrderType()==OP_SELL)
                 {
                  if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE))OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
                 }
              }
           }

         if(UseChandIfTouched)
           {
            for(i=0;i<OrdersTotal();i++)
              {
                if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
                  {
                   if(OrderType()==OP_BUY)
                     {
                      if(OrderStopLoss()<Chandelier_Up-Point)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Up-Point,OrderTakeProfit(),0,White);
                     }
                   if(OrderType()==OP_SELL)
                     {
                      if(OrderStopLoss()>Chandelier_Dn+Point+spread)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Dn+Point+spread,OrderTakeProfit(),0,White);
                     }
                  }
               }
           }

         for(i=0;i<OrdersTotal();i++)
           {
            if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
              {
               if(OrderType()==OP_BUY)LongTrades++;
               if(OrderType()==OP_SELL)ShortTrades++;
              }
           }
        }

      if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE))LongTradePrice=0;
      if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE))ShortTradePrice=0;
      if(TimeCurrent()>=LongTradeExpiration)LongTradePrice=0;
      if(TimeCurrent()>=ShortTradeExpiration)ShortTradePrice=0;

      WPR=iWPR(NULL,0,WPR_Period,1);
      if(WPR>=WPR_TopLevel)NextLongTrade=true;
      if(WPR<=WPR_BottomLevel)NextShortTrade=true;
      GoLong=false;
      GoShort=false;
      if(WPR<=WPR_BottomLevel)GoLong=true;
      if(WPR>=WPR_TopLevel)GoShort=true;

      if(LongTrades==0 || (AllowReentries && NextLongTrade))
        {
         SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
         SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
         if(SATL>SATL_Prev
         && (Close[0]>=SATL || !UseSATLFilter) 
         && Chandelier_Up!=EMPTY_VALUE 
         && Chandelier_Dn==EMPTY_VALUE 
         && Close[0]>=Chandelier_Up+ChandDist_Min*Point 
         && Close[0]<=Chandelier_Up+ChandDist_Max*Point 
         && GoLong)
           {
            CalculatePivots(true);
            if(FirstAbove!=0 && Close[0]>=FirstAbove+spread-(NextPivotMaxDist*Point))
              {
               LongTradePrice=Ask;
               LongTradeExpiration=0;
             }
            else
              {
               if(FirstBelow!=0)
                 {
                  LongTradePrice=FirstBelow+spread+(LastPivotMaxDist*Point);
                  LongTradeExpiration=TimeCurrent()+(60*PivotWaitingTime);
                 }
              }
           }
        }

      if(ShortTrades==0 || (AllowReentries && NextShortTrade))
        {
         SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
         SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
         if(SATL<SATL_Prev 
            && (Close[0]<=SATL || !UseSATLFilter) 
            && Chandelier_Up==EMPTY_VALUE 
            && Chandelier_Dn!=EMPTY_VALUE 
            && Close[0]<=Chandelier_Dn-ChandDist_Min*Point 
            && Close[0]>=Chandelier_Dn-ChandDist_Max*Point
            && GoShort)
           {
            CalculatePivots(false);
            if(FirstBelow!=0 && Close[0]<=FirstBelow+(NextPivotMaxDist*Point))
              {
               ShortTradePrice=Bid;
               ShortTradeExpiration=0;
              }
            else
              {
               if(FirstAbove!=0)
                 {
                  ShortTradePrice=FirstAbove-(LastPivotMaxDist*Point);
                  ShortTradeExpiration=TimeCurrent()+(60*PivotWaitingTime);
                 }
              }
           }
        }

      LastMinute=Time[0];
     }

   if(LongTradePrice!=0 && LongTradePrice>=Ask && (LongTrades==0 || (AllowReentries && NextShortTrade)))
     {
      if(MaximumRisk!=0)LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/(((Ask-(Chandelier_Up-Point))/Point)*10),1);
      if(LotSize<MarketInfo(Symbol(),MODE_MINLOT))LotSize=MarketInfo(Symbol(),MODE_MINLOT);
      if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT))LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
      if(atr_for_tp)TPPips=NormalizeDouble(atr_multiplier/(iATR(NULL,0,atr_period,1)/Point),0);
      if(UseChandIfTouched)res=OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,Chandelier_Up-Point,Ask+(TPPips*Point)-spread,"SimbaSystem",MAGICSS,0,Blue);
      else res=OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,0,Ask+(TPPips*Point)-spread,"SimbaSystem",MAGICSS,0,Blue);
      if(res>0)
        {
         if(OrderSelect(res,SELECT_BY_TICKET,MODE_TRADES))Print("BUY order opened :",OrderOpenPrice());
        }
      else Print("Error opening BUY order: ",ErrorDescription(GetLastError()));
      NextLongTrade=false;
      LongTradePrice=0;
     }

   if(ShortTradePrice!=0 && ShortTradePrice<=Bid && (ShortTrades==0 || (AllowReentries && NextShortTrade)))
     {
      if(MaximumRisk!=0)LotSize=NormalizeDouble((AccountFreeMargin()*MaximumRisk*0.01)/(((Ask-(Chandelier_Up-Point))/Point)*10),1);
      if(LotSize<MarketInfo(Symbol(),MODE_MINLOT))LotSize=MarketInfo(Symbol(),MODE_MINLOT);
      if(LotSize>MarketInfo(Symbol(),MODE_MAXLOT))LotSize=MarketInfo(Symbol(),MODE_MAXLOT);
      if(atr_for_tp)TPPips=NormalizeDouble(atr_multiplier/(iATR(NULL,PERIOD_D1,atr_period,1)/Point),0);
      if(UseChandIfTouched)res=OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,Chandelier_Dn+Point+spread,Bid-(TPPips*Point)+spread,"SimbaSystem",MAGICSS,0,Red);
      else res=OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,0,Bid-(TPPips*Point)+spread,"SimbaSystem",MAGICSS,0,Red);
      if(res>0)
        {
         if(OrderSelect(res,SELECT_BY_TICKET,MODE_TRADES))Print("SELL order opened :",OrderOpenPrice());
        }
      else Print("Error opening SELL order :",ErrorDescription(GetLastError()));
      NextShortTrade=false;
      ShortTradePrice=0;
     }

//----
   return(0);
  }

void CalculatePivots(bool direction)
  {
   double line[7];
   int i;

   line[1]=iCustom(NULL,0,"Dolly",6,0);
   line[2]=iCustom(NULL,0,"Dolly",4,0);
   line[3]=iCustom(NULL,0,"Dolly",2,0);
   line[4]=iCustom(NULL,0,"Dolly",0,0);
   line[5]=iCustom(NULL,0,"Dolly",1,0);
   line[6]=iCustom(NULL,0,"Dolly",3,0);
   line[7]=iCustom(NULL,0,"Dolly",5,0);
   FirstAbove=0;
   FirstBelow=0;
   for(i=1;i<=7;i++)
     {
      if(line[i]>=Close[0])
        {
         FirstAbove=i;
        }
     }
   for(i=7;i>=1;i--)
     {
      if(line[i]<=Close[0])
        {
         FirstBelow=i;
        }
     }

   if(direction)
     {
      if(FirstAbove<4)FirstAbove=0;
      if(FirstBelow<4)FirstBelow=4;
     }
   else
     {
      if(FirstBelow>4)FirstBelow=0;
      if(FirstAbove>4)FirstAbove=4;
     }

   if(FirstAbove!=0)FirstAbove=line[StrToInteger(DoubleToStr(FirstAbove,0))];
   if(FirstBelow!=0)FirstBelow=line[StrToInteger(DoubleToStr(FirstBelow,0))];
  }
//+------------------------------------------------------------------+